/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-24 at 19:40:24 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.gan.model;

/**
 * A ReportResource representing a report of a certain type either for an advertiser or publisher.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Affiliate Network API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Report extends com.google.api.client.json.GenericJson {

  /**
   * The column names for the report
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("column_names")
  private java.util.List<java.lang.String> columnNames;

  /**
   * The end of the date range for this report, exclusive.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("end_date")
  private java.lang.String endDate;

  /**
   * The kind for a report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The number of matching rows before paging is applied.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("matching_row_count") @com.google.api.client.json.JsonString
  private java.lang.Long matchingRowCount;

  /**
   * The rows of data for the report
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.util.List<java.lang.Object>> rows;

  /**
   * The start of the date range for this report, inclusive.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("start_date")
  private java.lang.String startDate;

  /**
   * The totals rows for the report
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("totals_rows")
  private java.util.List<java.util.List<java.lang.Object>> totalsRows;

  /**
   * The report type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * The column names for the report
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getColumnNames() {
    return columnNames;
  }

  /**
   * The column names for the report
   * @param columnNames columnNames or {@code null} for none
   */
  public Report setColumnNames(java.util.List<java.lang.String> columnNames) {
    this.columnNames = columnNames;
    return this;
  }

  /**
   * The end of the date range for this report, exclusive.
   * @return value or {@code null} for none
   */
  public java.lang.String getEndDate() {
    return endDate;
  }

  /**
   * The end of the date range for this report, exclusive.
   * @param endDate endDate or {@code null} for none
   */
  public Report setEndDate(java.lang.String endDate) {
    this.endDate = endDate;
    return this;
  }

  /**
   * The kind for a report.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind for a report.
   * @param kind kind or {@code null} for none
   */
  public Report setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The number of matching rows before paging is applied.
   * @return value or {@code null} for none
   */
  public java.lang.Long getMatchingRowCount() {
    return matchingRowCount;
  }

  /**
   * The number of matching rows before paging is applied.
   * @param matchingRowCount matchingRowCount or {@code null} for none
   */
  public Report setMatchingRowCount(java.lang.Long matchingRowCount) {
    this.matchingRowCount = matchingRowCount;
    return this;
  }

  /**
   * The rows of data for the report
   * @return value or {@code null} for none
   */
  public java.util.List<java.util.List<java.lang.Object>> getRows() {
    return rows;
  }

  /**
   * The rows of data for the report
   * @param rows rows or {@code null} for none
   */
  public Report setRows(java.util.List<java.util.List<java.lang.Object>> rows) {
    this.rows = rows;
    return this;
  }

  /**
   * The start of the date range for this report, inclusive.
   * @return value or {@code null} for none
   */
  public java.lang.String getStartDate() {
    return startDate;
  }

  /**
   * The start of the date range for this report, inclusive.
   * @param startDate startDate or {@code null} for none
   */
  public Report setStartDate(java.lang.String startDate) {
    this.startDate = startDate;
    return this;
  }

  /**
   * The totals rows for the report
   * @return value or {@code null} for none
   */
  public java.util.List<java.util.List<java.lang.Object>> getTotalsRows() {
    return totalsRows;
  }

  /**
   * The totals rows for the report
   * @param totalsRows totalsRows or {@code null} for none
   */
  public Report setTotalsRows(java.util.List<java.util.List<java.lang.Object>> totalsRows) {
    this.totalsRows = totalsRows;
    return this;
  }

  /**
   * The report type.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The report type.
   * @param type type or {@code null} for none
   */
  public Report setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public Report set(String fieldName, Object value) {
    return (Report) super.set(fieldName, value);
  }

  @Override
  public Report clone() {
    return (Report) super.clone();
  }

}
